<?
  /**
    読み込みクラス(2012/04/07)
    @author   TagajoTown
  */
  class Reader
  {
    /**
      リーダ本体。
      @param $s_exp S式
      @return シンボル、定数またはシンボルと定数の配列を返す
    */
    public static function read( $s_exp )
    {
      return self::parse( self::tokenize( $s_exp ) );
    }
  
    /**
      トークンに分割
      @param  $s_exp S式
      @return トークン配列
    */
    public static function tokenize( $s_exp )
    {
      $temp = str_replace( '(', ' ( ', $s_exp );
      $temp = str_replace( ')', ' ) ', $temp );
      return preg_split( '/\s+/', trim( $temp ) );
    }
    
    /**
      トークンをシンボルまたは定数の配列にする
      文法エラーのときは「SyntaxException」をスローする
      @param $tokens トークンの配列
      @return 定数、シンボルの配列
      @exception UnboundException
    */
    public static function parse( &$tokens )
    {
      if( count( $tokens ) <= 0 ) {
        return false;
      }
      
      $token = trim( array_shift( $tokens ) );
      if( $token == '(' ) {
        $array = array();
        while( trim( $tokens[ 0 ] ) != ')' ) {
          $array[] = self::parse( $tokens );
        }
        array_shift( $tokens );
        return $array;
        
      } elseif( $token == ')' ) {
        throw new SyntaxException( "Syntacs Error, Unexpected ')' \n" );
        
      } else {
        return Symbol::get_atom( $token );
      }
    }
  }

?>
