<?
  /**
    Symbolクラス(2012/04/07)
    @author   TagajoTown
  */
  class Symbol
  {
    public    $value;
    
    /**
      定数またはシンボルオブジェクトを作成する
      @param  $value Reader::tokenize()で作成されたトークン1つ
      @return 整数、浮動小数点数、文字列またはシンボルオブジェクト
      @see    Reader::parse()
    */
    public static function get_atom( $value )
    {
      switch( true ) {
      case is_numeric( $value ):
        if( ctype_digit( $value ) ) {
          return (int)$value;
        } else {
          return (float)$value;
        }
      case preg_match( '/^\".*\"$/', $value ):    // ダブルクォートで囲まれてるなら文字列
        return $value;
      default:
        return new Symbol( $value );
      }
    }
    
    public function __construct( $value )
    {
      $this->value  = $value;
    }
  }
  
?>
