<?
  /**
    LisPHPエントリポイント(2012/04/07)
    PHP5.1以降の使用にあわせて記述しました。
    
    @author   TagajoTown
    @version  1.0
  */
  
  include_once( dirname( __FILE__ ) . '/Symbol.php' );
  include_once( dirname( __FILE__ ) . '/Environment.php' );
  include_once( dirname( __FILE__ ) . '/Evaluate.php' );
  include_once( dirname( __FILE__ ) . '/Exceptions.php' );
  include_once( dirname( __FILE__ ) . '/Printer.php' );
  include_once( dirname( __FILE__ ) . '/Reader.php' );
  
  // 環境管理クラスはグローバル変数とする
  $global_environment = get_global_environment();
  
  /*
  (define area (lambda (r) (* 3.141592653 (* r r))))
  (define fact (lambda (n) (if (<= n 1) 1 (* n (fact (- n 1))))))
  (define first car)
  (define rest cdr)
  (define count (lambda (item L) (if L (+ (equal? item (first L)) (count item (rest L))) 0)))
  */
$help = <<<_EOF_
==> 終了するときは、「exit」と入力して下さい。\n
_EOF_;
  print( $help );
  
  $prompt = 'LisPHP>>';
  $stdin = fopen( "php://stdin", "r" );
  
  while( true ) {
    print( $prompt );
    $line = trim( fgets( $stdin ) );
    
    if( $line == 'exit' ) {
      break;
    }
    
    try {
      if( $line != "" ) {
        $symbols = Reader::read( $line );
        $val = Evaluator::lisp_eval( $symbols );
      }
    } catch( SyntacsException $e ) {
      print( $e->getMessage() );
    } catch( UnboundException $e ) {
      print( $e->getMessage() );
    }
    
    if( isSet( $val ) ) {
      print( Printer::to_string( $val ) );
    }
  }
  fclose( $stdin );
  
?>
